/// <reference types="react" />
import PropTypes from "prop-types";
import "../init";
import { FormElement } from "../formElement";
export declare type InputProps = FormElement;
export declare const Input: {
    (props: InputProps): JSX.Element;
    propTypes: {
        label: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        nullable: PropTypes.Requireable<boolean>;
        value: PropTypes.Requireable<string>;
        disabled: PropTypes.Requireable<boolean>;
        onChange: PropTypes.Requireable<(...args: any[]) => any>;
        className: PropTypes.Requireable<string>;
        placeholder: PropTypes.Requireable<string>;
    };
    defaultProps: {
        disabled: boolean;
        nullable: boolean;
    };
};
