/// <reference types="react" />
import PropTypes from "prop-types";
import { ButtonProps } from "../Button";
export interface ButtonGroupProps {
    buttons: ButtonProps[];
    color: "blue" | "green" | "red";
    className?: string;
}
export declare const ButtonGroup: {
    ({ buttons, color, className }: ButtonGroupProps): JSX.Element;
    propTypes: {
        buttons: PropTypes.Validator<any[]>;
        color: PropTypes.Requireable<string>;
        className: PropTypes.Requireable<string>;
    };
    defaultProps: {
        color: string;
    };
};
